
/* ************************************************************************
*  File: unactmob.c                                           Part of ACT *
*  Usage: Loading/saving chars, booting/resetting world, internal funcs   *
*                                                                         *
*  All rights reserved.  See license.doc for complete information.        *
*                                                                         *
*  Copyright (C) 1993, 94 by the Trustees of the Johns Hopkins University *
*  CircleMUD is based on DikuMUD, Copyright (C) 1990, 1991.               *
************************************************************************ */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "act.h"

char buf[MAX_STRING_LENGTH], buf1[MAX_STRING_LENGTH], buf2[MAX_STRING_LENGTH];
extern char *action_bits[];
extern char *affected_bits[];
extern char *genders[];
extern char *position_types[];

void parse_mobile(FILE * mob_f, int nr, FILE *actfile)
{
  int t[10], cnt;
  char line[256], letter, s[256], s1[256], s2[256];
  
  /***** String data *** */
  fread_string(mob_f, buf2, actfile);			/* Name */
  fread_string(mob_f, buf2, actfile);			/* Short Desc */
  fread_string(mob_f, buf2, actfile);			/* Long Desc */
  fread_string(mob_f, buf2, actfile);			/* Action Desc */

  /* *** Numeric data *** */
  get_line(mob_f, line, actfile);
  sscanf(line, "%s %s %d %c", s, s1, t + 2, &letter);
  fprintf(actfile, "%ld ", string_to_bitvector(s, action_bits));
  fprintf(actfile, "%ld ", string_to_bitvector(s1, affected_bits));
  fprintf(actfile, "%d %c\n", t[2], letter);

  switch (letter) {
  case 'S':						/* Simple monsters */
    get_line(mob_f, line, actfile);
    fprintf(actfile, "%s\n", line);			/* Lvl Hit AC HP DAM */

    get_line(mob_f, line, actfile);
    sscanf(line, " %d %d ", t, t + 1);
    fprintf(actfile, "%d %d\n", t[0], t[1]);		/* Gold Xp */

    get_line(mob_f, line, actfile);
    cnt = sscanf(line, "%s %s %s %d", s, s1, s2, t + 3);
    fprintf(actfile, "%ld ", string_to_select(s, position_types));
    fprintf(actfile, "%ld ", string_to_select(s1, position_types));
    fprintf(actfile, "%ld ", string_to_select(s2, genders));
    if (cnt == 4)
      fprintf(actfile, "%d", t[3]);
    fprintf(actfile, "\n");
    break;
  default:
    fprintf(stderr, "Unsupported mob type %c in mob #%d\n", letter, nr);
    exit(1);
    break;
  }
}

